// $Id$
//
// Copyright (C) 2010
//     Stefan Bund <info@j32.de>

/** \file
    \brief PDFWidget public header */

#ifndef HH_PyKit_PDFWidget_
#define HH_PyKit_PDFWidget_ 1

// Custom includes
#include <poppler/qt4/poppler-qt4.h>
#include <boost/scoped_ptr.hpp>
#include <QLabel>
#include <QString>
#include <QWidget>
#include <QNetworkAccessManager>
#include <QUrl>

//#include "PDFWidget.mpp"
///////////////////////////////hh.p////////////////////////////////////////

namespace pykit {

    class PDFWidget : public QLabel
    {
        Q_OBJECT;
    public:
        explicit PDFWidget(QString const & id, QNetworkAccessManager * manager,
                           QWidget * parent = 0);
        PDFWidget(QString const & id, QString const & document, QNetworkAccessManager * manager,
                  QWidget * parent = 0);

        void load(QUrl const & url);

    protected:
        virtual void resizeEvent(QResizeEvent * event);

    private slots:
        void netLoadDocument();

    private:
        void documentSetup();
        void showPage();

        QString id_;
        QNetworkAccessManager * manager_;
        boost::scoped_ptr<Poppler::Document> document_;
        int currentPage_;
        double dpi_;
    };

}

///////////////////////////////hh.e////////////////////////////////////////
//#include "PDFWidget.cci"
//#include "PDFWidget.ct"
//#include "PDFWidget.cti"
#endif


// Local Variables:
// mode: c++
// fill-column: 100
// comment-column: 40
// c-file-style: "j32"
// indent-tabs-mode: nil
// ispell-local-dictionary: "american"
// compile-command: "scons -U"
// End:
